/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.operator.keycloak;

import static org.assertj.core.api.Assertions.*;

import java.util.Optional;

import org.apache.commons.lang3.reflect.FieldUtils;
import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;
import org.keycloak.admin.client.Keycloak;
import org.keycloak.admin.client.KeycloakBuilder;
import org.keycloak.representations.idm.RoleRepresentation;
import org.mockito.InjectMocks;
import org.mockito.Spy;

@Disabled("Should only be used manually")
class KeycloakLivelTest {

	@Spy
	@InjectMocks
	private KeycloakGenericRemoteService service;

	@Test
	void testReal() throws IllegalAccessException {
		Keycloak kc = KeycloakBuilder.builder()
				.serverUrl("https://sso.dev.by.ozg-cloud.de")
				.realm("master")
				.username("admin")
				.password(" ")
				.clientId("admin-cli")
				.build();

		FieldUtils.writeField(service, "keycloak", kc, true);

		Optional<RoleRepresentation> rsp = service.getClientRole("VERWALTUNG_LOESCHEN", "alfa", "by-torsten-ozgcloud-keycloak-operator-dev");
		assertThat(rsp).isPresent();
	}
}
